import java.util.ArrayList;
import java.util.Iterator;

public class School
{
    private ArrayList<Student> sessel;

    public School()
    {
        sessel = new ArrayList<>(4);
    }

    public ArrayList<Student> getSessel()
    {
        return sessel;
    }

    public int getAnzahl()
    {
        return sessel.size();
    }

    public void aufnehmen(Student wen)
    {
        if (wen != null)
        {
            if (sessel.contains(wen) == false)
                sessel.add(wen);
            else
                System.out.println("Fehler: schon in dieser Schule!");
        }
        else
        {
            System.out.println("Fehler: kein Student!");
        }
    }

    public double avgAlter()
    {
        double summe;

        summe = 0;
        for (Student s : sessel)
        {
            summe = summe + s.getAlter();
        }
        if (sessel.size() > 0)
            return summe/sessel.size();
        else
        {
            System.out.println("Fehler: kein Student!");
            return -999.0;
        }
    }


    public void loschen(String name)
    {
        Student s;

        s = search(name);
        if (s != null)
        {
            sessel.remove(s);
        }
        else
        {
            System.out.println("Fehler: Student nicht gefunden!");
        }
    }


    public Student search(String name)
    {
        for (Student s : sessel)
        {
            if (s.getName().equalsIgnoreCase(name) == true)
            {
                return s;
            }
        }
        return null;
    }

    public boolean contains(Student s)
    {
        return sessel.contains(s);
    }

    public Student minAlter()
    {
        int min;
        Student wer;

        min = 9999;
        wer = null;
        for (Student s : sessel)
        {
            if (s.getAlter() < min)
            {
                min = s.getAlter();
                wer = s;
            }
        }
        if (wer != null)
        {
            return wer;
        }
        else
        {
            System.out.println("Fehler: kein Student");
            return wer;
        }
    }

    public int anzahlAbend()
    {
        int anz;

        anz = 0;
        for (Student s : sessel)
        {
            if (s.isAbendschuler() == true)
            {
                anz++;
            }
        }
        return anz;
    }

    public Student maxAlter()
    {
        return null;
    }
/*
    public void einfugen(int pos, Student wer)
    {
        if (wer != null)
        {
            if (anzahl < sessel.length)
            {
                if ((pos >= 0) && (pos <= anzahl))
                {
                    for (int i = anzahl - 1; i >= pos; i--)
                    {
                        sessel[i + 1] = sessel[i];
                    }
                    sessel[pos] = wer;
                    anzahl++;
                } else
                {
                    System.out.println("Fehler: ungültige Position!");
                }
            }
            else
            {
                System.out.println("Fehler: kein Platz!");
            }
        }
        else
        {
            System.out.println("Fehler: kein Student!");
        }
    }*/

    public void loschen(int pos)
    {
        if ((pos >= 0) && (pos < sessel.size()))
            sessel.remove(pos);
        else
            System.out.println("Fehler: ungültige Position!");
    }
    /*
    public void sortSelectionAlter()
    {

    }

    public void sortSelectionName()
    {

    }


    public void sortBubbleAlter()
    {
        Student h;
        boolean sorted;
        int j;

        j = 0;
        sorted = false;
        while(sorted == false)
        {
            sorted = true;
            for (int i = 0; i < anzahl-1-j; i++)
            {
                if (sessel[i].getAlter() > sessel[i + 1].getAlter())
                {
                    h = sessel[i + 1];
                    sessel[i + 1] = sessel[i];
                    sessel[i] = h;
                    sorted = false;
                }
            }
            j++;
        }
    }

    public void sortBubbleName()
    {
        Student h;
        boolean sorted;
        int j;

        j = 0;
        sorted = false;
        while(sorted == false)
        {
            sorted = true;
            for (int i = 0; i < anzahl-1-j; i++)
            {
                if (sessel[i].getName().compareTo(sessel[i + 1].getName()) > 0)
                {
                    h = sessel[i + 1];
                    sessel[i + 1] = sessel[i];
                    sessel[i] = h;
                    sorted = false;
                }
            }
            j++;
        }
    }
*/
    public String toString()
    {
        String erg;

        erg = "";
        for (Student s : sessel)
        {
            erg = erg + s.toString() + "\n";
        }
        return erg;
    }
}
